<div class="animated fadeIn">
  <div class="row">
    <div class="col-12">
      <div class="card">
        <div class="card-header d-flex align-items-center justify-content-between">
          <span>{{'monitor.ddos.world_map_top_10' | translate}}</span>
          <div class="d-flex align-items-center">
            <span class="pr-1">{{'common.period' | translate}} </span>
            <app-period [selectTime]="periodFilterChart.controls['worldMapChart'].value"
                        (changeValue)="periodFilterChart.controls['worldMapChart'].setValue($event);loadWorldMapTop()"
                        drop-type="right"
            >
            </app-period>
            <!--<select (change)="loadWorldMapTop()" [formControl]="periodFilterChart.controls['worldMapChart']"-->
            <!--name="period"-->
            <!--class="form-control"-->
            <!--style="width: auto">-->
            <!--<option *ngFor=" let period of periodWorldMapCharts" [ngValue]="period">-->
            <!--{{period.label}}-->
            <!--</option>-->
            <!--</select>-->
          </div>
        </div>
        <div class="card-body p-0">
          <ng-world-map [data]="dataWorldMap" *ngIf="dataWorldMap"></ng-world-map>
        </div>
      </div>
    </div>
    <div class="col-4 pb-4">
      <div class="card h-100">
        <div class="card-header d-flex align-items-center justify-content-between">
          <span>{{'monitor.ddos.world_pie_top_10' | translate}}</span>

          <div class="d-flex align-items-center">
            <span class="pr-1">{{'common.period' | translate}} </span>
            <app-period [selectTime]="periodFilterChart.controls['worldPieChart'].value"
                        (changeValue)="periodFilterChart.controls['worldPieChart'].setValue($event);loadWorldPieChart()"
                        drop-type="right"
            >
            </app-period>
            <!--<select (change)="loadWorldPieChart()" [formControl]="periodFilterChart.controls['worldPieChart']"-->
            <!--name="period" class="form-control"-->
            <!--style="width: auto">-->
            <!--<option *ngFor=" let period of periodWorldPieCharts" [ngValue]="period">-->
            <!--{{period.label}}-->
            <!--</option>-->
            <!--</select>-->

          </div>


        </div>
        <div class="card-body p-0">

          <div style="height: 500px" class="chart-wrapper d-flex align-items-center" *ngIf="worldPieChartDataSet">
            <canvas baseChart style="max-height: 500px" class="chart" *ngIf="worldPieChartDataSet.data.length > 0"
                    [colors]="worldPieChartDataSet.colors"
                    [chartType]="'pie'"
                    [data]="worldPieChartDataSet.data"
                    [labels]="worldPieChartDataSet.lables"></canvas>
          </div>


        </div>
      </div>
    </div>
    <div class="col-8">
      <div
        class="card p-0">
        <div class="card-header">
          {{'monitor.ddos.ip_bar_top_10' | translate}}
          <div class="card-header-actions">
            <div class="d-flex align-items-center">
              <span class="pr-1">{{'common.period' | translate}} </span>
              <app-period [selectTime]="periodFilterChart.controls['ipHorizonColumnChart'].value"
                          (changeValue)="periodFilterChart.controls['ipHorizonColumnChart'].setValue($event);loadIPHorizonColumnChart()"
                          drop-type="right"
              >
              </app-period>
              <!--<select (change)="loadWorldMapTop()" [formControl]="periodFilterChart.controls['worldMapChart']"-->
              <!--name="period"-->
              <!--class="form-control"-->
              <!--style="width: auto">-->
              <!--<option *ngFor=" let period of periodWorldMapCharts" [ngValue]="period">-->
              <!--{{period.label}}-->
              <!--</option>-->
              <!--</select>-->
            </div>
          </div>
        </div>
        <div class="card-body">
          <div class="chart-wrapper" *ngIf="ipHorizonColumnChartData">
            <canvas baseChart class="chart" #ipHorizonColumnChart='base-chart'
                    [datasets]="ipHorizonColumnChartData"
                    [labels]="ipHorizonColumnChartLabels"
                    [options]="webConnectionChartOption"
                    [legend]="lineChartLegend"
                    [chartType]="barChartType"
                    [plugins]="resourceChartPlugins"
            >
            </canvas>
          </div>
        </div>
      </div>
    </div>
    <div class="col-4 pb-4">
      <div class="card h-100">
        <div class="card-header d-flex align-items-center justify-content-between">
          <span>{{'monitor.ddos.website_chart_top_10' | translate}}</span>

          <div class="d-flex align-items-center">
            <span class="pr-1">{{'common.period' | translate}} </span>
            <app-period [selectTime]="periodFilterChart.controls['websitePieChart'].value"
                        (changeValue)="periodFilterChart.controls['websitePieChart'].setValue($event);loadWorldPieChart()"
                        drop-type="right"
            >
            </app-period>
            <!--<select (change)="loadWorldPieChart()" [formControl]="periodFilterChart.controls['worldPieChart']"-->
            <!--name="period" class="form-control"-->
            <!--style="width: auto">-->
            <!--<option *ngFor=" let period of periodWorldPieCharts" [ngValue]="period">-->
            <!--{{period.label}}-->
            <!--</option>-->
            <!--</select>-->

          </div>


        </div>
        <div class="card-body p-0">

          <div style="height: 500px" class="chart-wrapper d-flex align-items-center"
               *ngIf="attackWebsitePieTop10DataSet">
            <canvas baseChart style="max-height: 500px" class="chart"
                    *ngIf="attackWebsitePieTop10DataSet.data.length > 0"
                    [colors]="attackWebsitePieTop10DataSet.colors"
                    [chartType]="'pie'"
                    [data]="attackWebsitePieTop10DataSet.data"
                    [labels]="attackWebsitePieTop10DataSet.lables"></canvas>
          </div>


        </div>
      </div>
    </div>
    <div class="col-8">
      <div
        class="card p-0">
        <div class="card-header">
          {{'monitor.ddos.website_bar_top_10' | translate}}
          <div class="card-header-actions">
            <div class="d-flex align-items-center">
              <span class="pr-1">{{'common.period' | translate}} </span>
              <app-period [selectTime]="periodFilterChart.controls['websiteHorizonColumnChart'].value"
                          (changeValue)="periodFilterChart.controls['websiteHorizonColumnChart'].setValue($event);loadWebsiteTop10ColumnChart()"
                          drop-type="right"
              >
              </app-period>
              <!--<select (change)="loadWorldMapTop()" [formControl]="periodFilterChart.controls['worldMapChart']"-->
              <!--name="period"-->
              <!--class="form-control"-->
              <!--style="width: auto">-->
              <!--<option *ngFor=" let period of periodWorldMapCharts" [ngValue]="period">-->
              <!--{{period.label}}-->
              <!--</option>-->
              <!--</select>-->
            </div>
          </div>
        </div>
        <div class="card-body">
          <div class="chart-wrapper" *ngIf="websiteTop10HorizonBarChartData">
            <canvas baseChart class="chart" #websiteTop10HorizonBarChart='base-chart'
                    [datasets]="websiteTop10HorizonBarChartData"
                    [labels]="websiteTop10HorizonBarChartLabels"
                    [options]="webConnectionChartOption"
                    [legend]="lineChartLegend"
                    [chartType]="barChartType"
                    [plugins]="resourceChartPlugins"
            >
            </canvas>
          </div>
        </div>
      </div>
    </div>


    <!--end 12 cell-->
  </div>

  <!--network-->
  <div class="row">


    <div class="col-lg-12">
      <div class="card">
        <div class="card-header">
          {{'monitor.ddos.network_layer_log' | translate}}
        </div>
        <div class="card-body" style="padding-bottom: 50px">

          <div class="row mb-2">
            <div class="col-8 mb-2 d-flex align-items-center">
              <button class="btn btn-primary" (click)="refreshSearchFormNetwork()">
                <i class="fa fa-refresh"></i>
                <span class="d-none d-md-inline">{{'common.refresh' | translate}}</span>
              </button>

              <a class="btn btn-primary ml-2" (click)="onDownload(urlDownloadNetwork)"
                 [ngClass]="monitorDdossNetwork.length <= 0? 'disabled' : ''">
                <i class="fa fa-download"></i>
                <span class="d-none d-md-inline">{{'common.download' | translate}}</span>
              </a>

              <div class="ml-2 mr-2">
                <i class="fa fa-calendar"></i>
                <span class="d-none d-md-inline">{{'common.period' | translate}}</span>
              </div>
              <app-period [selectTime]="dataFilterNetworkForm.controls['period'].value"
                          (changeValue)="dataFilterNetworkForm.controls['period'].setValue($event);loadNetwork()"
              >
              </app-period>
              <!--<select (change)="changePeriodFilterFormNetwork()"-->
              <!--[formControl]="dataFilterNetworkForm.controls['period']" name="period"-->
              <!--class="form-control float-left ml-2"-->
              <!--style="width: auto">-->
              <!--<option *ngFor=" let period of periodFilterForms" [ngValue]="period">-->
              <!--{{period.label}}-->
              <!--</option>-->
              <!--</select>-->
            </div>
            <div class="col-4 d-flex justify-content-end align-items-center">
              <span class="pr-3">{{'common.show' | translate}}</span>
              <select (change)="changeLimitNetwork()" [(ngModel)]="pagingNetwork.limit" class="form-control"
                      style="max-width: 70px">
                <option *ngFor="let limitElement of limits" value="{{limitElement}}">{{limitElement}}</option>
              </select>
            </div>
            <div class="col-12">
              <app-ng-mutifilter [fields]="fieldsNetwork" (filter)="onFilterNetwork($event)">

              </app-ng-mutifilter>
              <!--<div class="input-group" style="max-width: 300px">-->
              <!--<div class="input-group-append">-->
              <!--<button (click)="searchNetwork()" class="btn btn-dark" type="button">-->
              <!--<i class="fa fa-filter"></i>-->
              <!--</button>-->
              <!--</div>-->
              <!--<input [formControl]="dataFilterNetworkForm.controls['filter']" type="text" class="form-control"-->
              <!--placeholder="{{'common.filter' | translate}}">-->
              <!--</div>-->
            </div>


          </div>

          <!--end row-->
          <table class="table table-bordered table-sort-icon" [formGroup]="accountFormGroup">
            <thead>
            <tr appSort [orderType]="orderNetwork.orderType" [orderBy]="orderNetwork.orderBy"
                (orderChange)="changeOderNetwork($event)">
              <th>{{'monitor.ddos.ordinal_numbers' | translate}}</th>
              <th appSortBy="attacker_ip">{{'monitor.ddos.ip_addr' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="datetime">{{'monitor.ddos.blocked_time' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="attacker_country">{{'monitor.ddos.country' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="group_rule">{{'monitor.ddos.rule' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="unlock">{{'monitor.ddos.unlock' | translate}}
                <fa-icon></fa-icon>
              </th>
            </tr>
            </thead>
            <tbody>
            <tr 
              class="tooltip__initiator" 
              *ngFor="let monitorDdos of monitorDdossNetwork; index as i" [attr.data-index]="i"
              (mouseenter)="showDetailNetwork(monitorDdos)" (mouseleave)="monitorDdos.is_show = false"
              [formGroupName]="i"
            >
              <td class="text-center">{{i + pagingNetwork.offset}}</td>
              <td>{{monitorDdos.ip_addr}}</td>
              <td class="text-center">{{monitorDdos.block_time}}</td>
              <td>
                <span><i class="flag-icon flag-icon-{{monitorDdos.country.toLocaleLowerCase()}}"></i></span>
                {{showCountry(monitorDdos.country)}}
                <div class="_tooltip tooltip__initiator" *ngIf="monitorDdos.is_show" style="z-index: 1000 !important">
                  <div class="tooltip__item" style="z-index: 1000 !important;">
                    <div class="pre-scroll" *ngIf="monitorDdos.detail">
                      <pre style="overflow: visible;">{{monitorDdos.detail}}</pre>
                    </div>
                    <div class="spinner" *ngIf="!monitorDdos.detail">
                      <div class="bounce1"></div>
                      <div class="bounce2"></div>
                      <div class="bounce3"></div>
                    </div>
                  </div>
                </div>
              </td>
              <td>{{monitorDdos.rule}}</td>
              <td class="text-center">
                <button *ngIf="monitorDdos.unlock === 0" class="btn btn-primary btn-sm"
                        (click)="lockIpNet(monitorDdos.block_time, monitorDdos.ip_addr)">
                  <i class="fa fa-lock"></i>
                  <span class="d-none d-md-inline">{{'monitor.ddos.block' | translate}}</span>
                </button>
                <button *ngIf="monitorDdos.unlock === 1" class="btn btn-primary btn-sm" disabled>
                  <i class="fa fa-unlock"></i>
                  <span class="d-none d-md-inline">{{'monitor.ddos.unblock' | translate}}</span>
                </button>
              </td>
            </tr>
            </tbody>
          </table>
          <div class="row">
            <div class="col-12">

              <span *ngIf="monitorDdossNetwork.length !== 0" style="line-height: 33px" class="float-left">
                {{'common.pagingInfo' | translate : {
                start: pagingNetwork.offset + 1,
                end: (pagingNetwork.offset + monitorDdossNetwork.length),
                total: pagingNetwork.total
              } }}
              </span>
              <div *ngIf="!monitorDdossNetwork || monitorDdossNetwork.length === 0" class="text-center">
                <span>{{'common.no_record' | translate}}</span>
              </div>
              <ngb-pagination *ngIf="monitorDdossNetwork.length !== 0" class="float-right" [boundaryLinks]="true"
                              [collectionSize]="pagingNetwork.total"
                              [pageSize]="pagingNetwork.limit" [maxSize]="5" [rotate]="true"
                              [(page)]="pagingNetwork.page"
                              (pageChange)="loadPage(pagingNetwork.page,pagingNetwork,false)">
              </ngb-pagination>
            </div>

          </div>

        </div>
      </div>
    </div>

  </div>

  <!--application-->
  <div class="row">


    <div class="col-lg-12">
      <div class="card">
        <div class="card-header">
          {{'monitor.ddos.application_log' | translate}}
        </div>
        <div class="card-body" style="padding-bottom: 300px">

          <div class="row mb-2">
            <div class="col-8 mb-2 d-flex align-items-center">
              <button class="btn btn-primary" (click)="refreshSearchFormApplication()">
                <i class="fa fa-refresh"></i>
                <span class="d-none d-md-inline">{{'common.refresh' | translate}}</span>
              </button>

              <a class="btn btn-primary ml-2" (click)="onDownload(urlDownloadApplication)"
                 [ngClass]="monitorDdossApplication.length <= 0? 'disabled' : ''">
                <i class="fa fa-download"></i>
                <span class="d-none d-md-inline">{{'common.download' | translate}}</span>
              </a>

              <div class="ml-2 mr-2">
                <i class="fa fa-calendar"></i>
                <span class="d-none d-md-inline">{{'common.period' | translate}}</span>
              </div>
              <app-period [selectTime]="dataFilterApplicationForm.controls['period'].value"
                          (changeValue)="dataFilterApplicationForm.controls['period'].setValue($event);loadApplication()"
              >
              </app-period>
              <!--<select (change)="changePeriodFilterFormApplication()"-->
              <!--[formControl]="dataFilterApplicationForm.controls['period']" name="period"-->
              <!--class="form-control float-left ml-2"-->
              <!--style="width: auto">-->
              <!--<option *ngFor=" let period of periodFilterForms" [ngValue]="period">-->
              <!--{{period.label}}-->
              <!--</option>-->
              <!--</select>-->
            </div>
            <div class="col-4 d-flex align-items-center justify-content-end">
              <span class="pr-3" style="line-height: 33px">{{'common.show' | translate}}</span>
              <select (change)="changeLimitApplication()" [(ngModel)]="pagingApplication.limit" class="form-control"
                      style="max-width: 70px">
                <option *ngFor="let limitElement of limits" value="{{limitElement}}">{{limitElement}}</option>
              </select>
            </div>


            <div class="col-12">
              <!--<div class="input-group" style="max-width: 300px">-->
              <!--<div class="input-group-append">-->
              <!--<button (click)="searchApplication()" class="btn btn-dark" type="button">-->
              <!--<i class="fa fa-filter"></i>-->
              <!--</button>-->
              <!--</div>-->
              <!--<input [formControl]="dataFilterApplicationForm.controls['filter']" type="text" class="form-control"-->
              <!--placeholder="{{'common.filter' | translate}}">-->
              <!--</div>-->

              <app-ng-mutifilter [fields]="fieldsApplication" (filter)="onFilterApplication($event)">

              </app-ng-mutifilter>

            </div>


          </div>

          <!--end row-->
          <table class="table table-bordered table-sort-icon">
            <thead>
            <tr appSort [orderType]="orderApplication.orderType" [orderBy]="orderApplication.orderBy"
                (orderChange)="changeOderApplication($event)">
              <th>{{'monitor.ddos.ordinal_numbers' | translate}}</th>
              <th appSortBy="attacker_ip">{{'monitor.ddos.ip_addr' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="datetime">{{'monitor.ddos.blocked_time' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="attacker_country">{{'monitor.ddos.country' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="group_rule">{{'monitor.ddos.rule' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="website_domain">Website
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="unlock">{{'monitor.ddos.unlock' | translate}}
                <fa-icon></fa-icon>
              </th>
            </tr>
            </thead>
            <tbody *ngIf="monitorDdossApplication">

            <tr class="tooltip__initiator" 
                *ngFor="let monitorDdos of monitorDdossApplication; index as i"
                (mouseenter)="showDetailApplication(monitorDdos)" (mouseleave)="monitorDdos.is_show = false"
            >
              <td class="text-center">{{i + pagingApplication.offset + 1}}</td>
              <td>{{monitorDdos.ip_addr}}</td>
              <td class="text-center">{{monitorDdos.block_time}}</td>
              <td>
                <span><i class="flag-icon flag-icon-{{monitorDdos.country.toLocaleLowerCase()}}"></i></span>
                {{showCountry(monitorDdos.country)}}
                <div class="_tooltip tooltip__initiator" *ngIf="monitorDdos.is_show" >
                  <div class="tooltip__item" style="left: 103px;">
                    <div class="pre-scroll" *ngIf="monitorDdos.detail">
                      <pre style="overflow: visible;">{{monitorDdos.detail}}</pre>
                    </div>
                    <div class="spinner" *ngIf="!monitorDdos.detail">
                      <div class="bounce1"></div>
                      <div class="bounce2"></div>
                      <div class="bounce3"></div>
                    </div>
                  </div>
                </div>
              </td>
              <td>{{monitorDdos.rule}}</td>
              <td>{{monitorDdos.website}}</td>
              <td class="text-center">
                <button *ngIf="monitorDdos.unlock === 0" class="btn btn-primary btn-sm"
                        (click)="lockIpApp(monitorDdos.block_time, monitorDdos.ip_addr)">
                  <i class="fa fa-lock"></i>
                  <span class="d-none d-md-inline">Khóa</span>
                </button>
                <button *ngIf="monitorDdos.unlock ===1" class="btn btn-primary btn-sm" disabled>
                  <i class="fa fa-unlock"></i>
                  <span class="d-none d-md-inline">Không khóa</span>
                </button>
              </td>
            </tr>
            </tbody>
          </table>

          <div class="row">
            <div class="col-12">

              <span *ngIf="monitorDdossApplication.length !== 0" style="line-height: 33px" class="float-left">
                {{'common.pagingInfo' | translate : {
                start: pagingApplication.offset + 1,
                end: (pagingApplication.offset + monitorDdossApplication.length),
                total: pagingApplication.total
              } }}
              </span>
              <div *ngIf="!monitorDdossApplication || monitorDdossApplication.length === 0" class="text-center">
                <span>{{'common.no_record' | translate}}</span>
              </div>
              <ngb-pagination *ngIf="monitorDdossApplication.length !== 0" class="float-right" [boundaryLinks]="true"
                              [collectionSize]="pagingApplication.total"
                              [pageSize]="pagingApplication.limit" [maxSize]="5" [rotate]="true"
                              [(page)]="pagingApplication.page"
                              (pageChange)="loadPage(pagingApplication.page,pagingApplication,true)">
              </ngb-pagination>
            </div>

          </div>

        </div>
      </div>
    </div>

  </div>
  <!--end row-->
</div>
